// CG_ProjektDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "CG_Projekt.h"
#include "CG_ProjektDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCG_ProjektDlg Dialogfeld

CCG_ProjektDlg::CCG_ProjektDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCG_ProjektDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCG_ProjektDlg)
	m_csStatus = _T("Zum Start Button Init klicken.");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCG_ProjektDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCG_ProjektDlg)
	DDX_Control(pDX, IDC_BUTTON_TEXTURE, m_cbTexture);
	DDX_Control(pDX, IDC_BUTTON_FOG, m_cbFog);
	DDX_Control(pDX, IDC_BUTTON_BEAMER, m_cbBeamer);
	DDX_Control(pDX, IDC_BUTTON_ZBUFFER, m_cbZbuffer);
	DDX_Control(pDX, IDC_BUTTON_PROJECTION, m_cbProjection);
	DDX_Control(pDX, IDC_BUTTON_STRAHLER, m_cbStrahler);
	DDX_Control(pDX, IDC_BUTTON_KOS, m_cbKos);
	DDX_Control(pDX, IDC_BUTTON_FILL_MODE, m_cbFillMode);
	DDX_Control(pDX, IDC_BUTTON_BLEND, m_cbBlend);
	DDX_Control(pDX, IDC_BUTTON_SHADING, m_cbShading);
	DDX_Control(pDX, IDC_BUTTON_PUNKT, m_cbPunkt);
	DDX_Control(pDX, IDC_BUTTON_PARALLEL, m_cbParallel);
	DDX_Control(pDX, IDC_BUTTON_LIGHTING, m_cbLighting);
	DDX_Control(pDX, IDC_BUTTON_LIGHT, m_cbLight);
	DDX_Control(pDX, IDC_BUTTON_INIT, m_cbInit);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_csStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCG_ProjektDlg, CDialog)
	//{{AFX_MSG_MAP(CCG_ProjektDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_BLEND, OnButtonBlend)
	ON_BN_CLICKED(IDC_BUTTON_LIGHTING, OnButtonLighting)
	ON_BN_CLICKED(IDC_BUTTON_LIGHT, OnButtonLight)
	ON_BN_CLICKED(IDC_BUTTON_FILL_MODE, OnButtonFillMode)
	ON_BN_CLICKED(IDC_BUTTON_KOS, OnButtonKos)
	ON_BN_CLICKED(IDC_BUTTON_PARALLEL, OnButtonParallel)
	ON_BN_CLICKED(IDC_BUTTON_PUNKT, OnButtonPunkt)
	ON_BN_CLICKED(IDC_BUTTON_SHADING, OnButtonShading)
	ON_BN_CLICKED(IDC_BUTTON_STRAHLER, OnButtonStrahler)
	ON_BN_CLICKED(IDC_BUTTON_PROJECTION, OnButtonProjection)
	ON_BN_CLICKED(IDC_BUTTON_ZBUFFER, OnButtonZbuffer)
	ON_BN_CLICKED(IDC_BUTTON_BEAMER, OnButtonBeamer)
	ON_BN_CLICKED(IDC_BUTTON_FOG, OnButtonFog)
	ON_BN_CLICKED(IDC_BUTTON_TEXTURE, OnButtonTexture)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCG_ProjektDlg Nachrichten-Handler

BOOL CCG_ProjektDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetWindowPos(NULL, 0, 0, NULL, NULL, SWP_NOSIZE | 
					SWP_NOZORDER | SWP_SHOWWINDOW);

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CCG_ProjektDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CCG_ProjektDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CCG_ProjektDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCG_ProjektDlg::OnButtonInit() 
{
	// Initialisiert das OpenGL Fenster

	m_pOpenGL = new COpenGL();			// neue COpenGL-Instanz erzeugen

	if (m_pOpenGL != NULL)
	{
		if (m_pOpenGL->InitOpenGL())
		{
			// Init-Button deaktivieren
			m_cbInit.EnableWindow(false);

			// Schaltflchen aktivieren
			m_cbLight.EnableWindow(true);
			m_cbLighting.EnableWindow(true);
			m_cbParallel.EnableWindow(true);
			m_cbPunkt.EnableWindow(true);
			m_cbShading.EnableWindow(true);
			m_cbSpot.EnableWindow(true);
			m_cbBlend.EnableWindow(true);
			m_cbFillMode.EnableWindow(true);
			m_cbKos.EnableWindow(true);
			m_cbStrahler.EnableWindow(true);
			m_cbProjection.EnableWindow(true);
			m_cbZbuffer.EnableWindow(true);
			m_cbBeamer.EnableWindow(true);
			m_cbFog.EnableWindow(true);
			m_cbTexture.EnableWindow(true);

			// Fenster darstellen
			m_pOpenGL ->ShowWindow(SW_SHOWNOACTIVATE);
			m_pOpenGL ->OpenGLSzene();
	
			//Statusfeld aktualisieren
			m_csStatus = CString(
				"Init erfolgreich!");
			return;
		};
	}
	else
	{
		m_csStatus = CString(
			"Fehler bei Init!!");
	}
	UpdateData(false);
	
}

void CCG_ProjektDlg::OnButtonBlend() 
{
	// Schaltet die Objekte der Szene transparent

	if (m_pOpenGL->m_structOGLStatus.bBlend == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bBlend = GL_FALSE;
		m_csStatus = CString("Transparenzeffekte abgeschaltet");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bBlend = GL_TRUE;
		m_csStatus = CString("Transparenzeffekte aktiviert");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();
//	m_pOpenGL->SetAttribs();
//	m_pOpenGL->DrawScene();
}

void CCG_ProjektDlg::OnButtonLighting() 
{
	// Art der Beleuchtung (GL_LIGHTING oder GL_MATERIAL)

	if (m_pOpenGL->m_structOGLStatus.bLightMode == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bLightMode = GL_FALSE;
		m_csStatus = CString("glMaterial Modus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bLightMode = GL_TRUE;
		m_csStatus = CString("glColor Modus");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();
	
}

void CCG_ProjektDlg::OnButtonLight() 
{
	// Beleuchtungsmodus an/ausschalten

	if (m_pOpenGL->m_structOGLStatus.bLight == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bLight = GL_FALSE;
		m_csStatus = CString("Beleuchtungseffekte abgeschaltet");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bLight = GL_TRUE;
		m_csStatus = CString("Beleuchtungseffekte aktiviert");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
	
}

void CCG_ProjektDlg::OnButtonFillMode() 
{
	// Gitternetzdarstellung an/aus

	if (m_pOpenGL->m_structOGLStatus.bFillModeLines == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bFillModeLines = GL_FALSE;
		m_csStatus = CString("Gitternetzmodus abgeschaltet");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bFillModeLines = GL_TRUE;
		m_csStatus = CString("Gitternetzmodus aktiviert");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
	
}

void CCG_ProjektDlg::OnButtonKos() 
{
	// Koordinatensystem zeichnen oder nicht?
	if (m_pOpenGL->m_structOGLStatus.bKos == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bKos = GL_FALSE;
		m_csStatus = CString("Kein Koordinatensystem zeichnen");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bKos = GL_TRUE;
		m_csStatus = CString("Koordinatensystem - x-Achse (Rot), y-Achse (grn), z-Achse (blau)");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
}

void CCG_ProjektDlg::OnButtonParallel() 
{
	// Schaltet den Parallelstrahler ein (Light0)
		if (m_pOpenGL->m_structOGLStatus.bLight0 == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bLight0 = GL_FALSE;
		m_csStatus = CString("Parallelstrahler aus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bLight0 = GL_TRUE;
		m_csStatus = CString("Parallelstrahler an");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
}

void CCG_ProjektDlg::OnButtonPunkt() 
{
	// Schaltet die Laterne ein (Light1)
		if (m_pOpenGL->m_structOGLStatus.bLight1 == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bLight1 = GL_FALSE;
		m_csStatus = CString("Laterne aus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bLight1 = GL_TRUE;
		m_csStatus = CString("Laterne an");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();
}

void CCG_ProjektDlg::OnButtonShading() 
{
	// Wechselt die Schattierungsart
		if (m_pOpenGL->m_structOGLStatus.bShadingSmooth == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bShadingSmooth = GL_FALSE;
		m_csStatus = CString("Schattierungsart: Flat-Shading");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bShadingSmooth = GL_TRUE;
		m_csStatus = CString("Schattierungsart: Smooth-Shading");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
}

void CCG_ProjektDlg::OnButtonStrahler() 
{
	// Schaltet den Strahler am linken Arm des Robo ein
	if (m_pOpenGL->m_structOGLStatus.bLight2 == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bLight2 = GL_FALSE;
		m_csStatus = CString("Strahler deaktiviert");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bLight2 = GL_TRUE;
		m_csStatus = CString("Strahler aktiviert");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();	
}

void CCG_ProjektDlg::OnButtonProjection() 
{
	// Schaltet zwischen Parallel- und Zentralprojektion um
	if (m_pOpenGL->m_structOGLStatus.bPerspective == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bPerspective = GL_FALSE;
		m_csStatus = CString("Parallelprojektion");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bPerspective = GL_TRUE;
		m_csStatus = CString("Zentralprojektion");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();	
}

void CCG_ProjektDlg::OnButtonZbuffer() 
{
	// Z-Buffer einschalten
	if (m_pOpenGL->m_structOGLStatus.bZbuffer == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bZbuffer = GL_FALSE;
		m_csStatus = CString("Z-Buffer aus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bZbuffer = GL_TRUE;
		m_csStatus = CString("Z-Buffer an");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
	
}

void CCG_ProjektDlg::OnButtonBeamer() 
{
	// schaltet den Beamer an oder ab
	if (m_pOpenGL->m_structOGLStatus.bBeamer == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bBeamer = GL_FALSE;
		m_csStatus = CString("Beamer aus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bBeamer = GL_TRUE;
		m_csStatus = CString("Beamer an");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();
	
}

void CCG_ProjektDlg::OnButtonFog() 
{
	// Nebel an/aus
	if (m_pOpenGL->m_structOGLStatus.bFog == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bFog = GL_FALSE;
		m_csStatus = CString("Nebel aus");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bFog = GL_TRUE;
		m_csStatus = CString("Nebel an");
	}
	UpdateData(false);

	m_pOpenGL->SetAttribs();
	m_pOpenGL->DrawScene();
}

void CCG_ProjektDlg::OnButtonTexture() 
{
	// Texturen an / aus
	if (m_pOpenGL->m_structOGLStatus.bTexture == GL_TRUE)
	{
		m_pOpenGL->m_structOGLStatus.bTexture = GL_FALSE;
		m_csStatus = CString("Texturen abgeschaltet");
	}
	else
	{
		m_pOpenGL->m_structOGLStatus.bTexture = GL_TRUE;
		m_csStatus = CString("Texturen aktiviert");
	}
	UpdateData(false);

	m_pOpenGL->OpenGLSzene();
}
