// CG_ProjektDlg.h : Header-Datei
//

#if !defined(AFX_CG_PROJEKTDLG_H__672E174B_CDBF_464D_BD41_EA91799466C6__INCLUDED_)
#define AFX_CG_PROJEKTDLG_H__672E174B_CDBF_464D_BD41_EA91799466C6__INCLUDED_

// eingebundene Bibliotheken
#include "OpenGL.h"
//#include "glu.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCG_ProjektDlg Dialogfeld

class CCG_ProjektDlg : public CDialog
{
// Konstruktion
public:
	CCG_ProjektDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CCG_ProjektDlg)
	enum { IDD = IDD_CG_PROJEKT_DIALOG };
	CButton	m_cbTexture;
	CButton	m_cbFog;
	CButton	m_cbBeamer;
	CButton	m_cbZbuffer;
	CButton	m_cbProjection;
	CButton	m_cbStrahler;
	CButton	m_cbKos;
	CButton	m_cbFillMode;
	CButton	m_cbBlend;
	CButton	m_cbSpot;
	CButton	m_cbShading;
	CButton	m_cbPunkt;
	CButton	m_cbParallel;
	CButton	m_cbLighting;
	CButton	m_cbLight;
	CButton	m_cbInit;
	CString	m_csStatus;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CCG_ProjektDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	COpenGL* m_pOpenGL;
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CCG_ProjektDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonInit();
	afx_msg void OnButtonBlend();
	afx_msg void OnButtonLighting();
	afx_msg void OnButtonLight();
	afx_msg void OnButtonFillMode();
	afx_msg void OnButtonKos();
	afx_msg void OnButtonParallel();
	afx_msg void OnButtonPunkt();
	afx_msg void OnButtonShading();
	afx_msg void OnButtonStrahler();
	afx_msg void OnButtonProjection();
	afx_msg void OnButtonZbuffer();
	afx_msg void OnButtonBeamer();
	afx_msg void OnButtonFog();
	afx_msg void OnButtonTexture();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_CG_PROJEKTDLG_H__672E174B_CDBF_464D_BD41_EA91799466C6__INCLUDED_)
